The Route Optimization API.

- [REST Resource: v1.operations](https://developers.google.com/maps/documentation/route-optimization/reference/rest#v1.operations)
- [REST Resource: v1.projects](https://developers.google.com/maps/documentation/route-optimization/reference/rest#v1.projects)
- [REST Resource: v1.projects.locations](https://developers.google.com/maps/documentation/route-optimization/reference/rest#v1.projects.locations)
- [REST Resource: v1.projects.locations.operations](https://developers.google.com/maps/documentation/route-optimization/reference/rest#v1.projects.locations.operations)

## Service: routeoptimization.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://routeoptimization.googleapis.com/$discovery/rest?version=v1>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://routeoptimization.googleapis.com`

## REST Resource: [v1.operations](https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/operations)

| Methods ||
|---|---|
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/operations/cancel` | `POST /v1/{name=operations/**}:cancel` (Currently unsupported) Starts asynchronous cancellation on a long-running operation. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/operations/delete` | `DELETE /v1/{name=operations/**}` (Currently unsupported) Deletes a long-running operation. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/operations/list` | `GET /v1/{name=operations}` (Currently unsupported) Lists operations that match the specified filter in the request. |

## REST Resource: [v1.projects](https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects)

| Methods ||
|---|---|
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects/batchOptimizeTours` | `POST /v1/{parent=projects/*}:batchOptimizeTours` Optimizes vehicle tours for one or more `OptimizeToursRequest` messages as a batch. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects/optimizeTours` | `POST /v1/{parent=projects/*}:optimizeTours` Sends an `OptimizeToursRequest` containing a `ShipmentModel` and returns an `OptimizeToursResponse` containing `ShipmentRoute`s, which are a set of routes to be performed by vehicles minimizing the overall cost. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects/optimizeToursLongRunning` | `POST /v1/{parent=projects/*}:optimizeToursLongRunning` This is a variant of the `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeTours#google.maps.routeoptimization.v1.RouteOptimization.OptimizeTours` method designed for optimizations with large timeout values. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects/optimizeToursUri` | `POST /v1/{parent=projects/*}:OptimizeToursUri` This is a variant of the `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeToursLongRunning#google.maps.routeoptimization.v1.RouteOptimization.OptimizeToursLongRunning` method designed for optimizations with large timeout values and large input/output sizes. |

## REST Resource: [v1.projects.locations](https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations)

| Methods ||
|---|---|
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/batchOptimizeTours` | `POST /v1/{parent=projects/*/locations/*}:batchOptimizeTours` Optimizes vehicle tours for one or more `OptimizeToursRequest` messages as a batch. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeTours` | `POST /v1/{parent=projects/*/locations/*}:optimizeTours` Sends an `OptimizeToursRequest` containing a `ShipmentModel` and returns an `OptimizeToursResponse` containing `ShipmentRoute`s, which are a set of routes to be performed by vehicles minimizing the overall cost. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeToursLongRunning` | `POST /v1/{parent=projects/*/locations/*}:optimizeToursLongRunning` This is a variant of the `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeTours#google.maps.routeoptimization.v1.RouteOptimization.OptimizeTours` method designed for optimizations with large timeout values. |
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeToursUri` | `POST /v1/{parent=projects/*/locations/*}:OptimizeToursUri` This is a variant of the `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations/optimizeToursLongRunning#google.maps.routeoptimization.v1.RouteOptimization.OptimizeToursLongRunning` method designed for optimizations with large timeout values and large input/output sizes. |

## REST Resource: [v1.projects.locations.operations](https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations.operations)

| Methods ||
|---|---|
| `https://developers.google.com/maps/documentation/route-optimization/reference/rest/v1/projects.locations.operations/get` | `GET /v1/{name=projects/*/locations/*/operations/*}` Gets the latest state of a long-running operation. |